using System;
using System.Collections.Generic;
using System.Reactive.Joins;
using System.Text.RegularExpressions;
using Avalonia.Input;
using Avalonia.Win32.Input;
using MsBox.Avalonia;
using MsBox.Avalonia.Enums;
using ReactiveUI;
using Tmds.DBus.Protocol;

namespace CaptchaAndSimpleCalculator.ViewModels
{
    public class CalculatorViewModel : ReactiveObject
    {
        public List<string> operations = new List<string>
        {
            "",
            "",
            "",
            ""
        };
        int selectedOperatValue = 0;
        string item1;
        string item2;
        string _operationSymbol;
        string _selectedOperation;

        public List<string> Operations { get => operations; set => this.RaiseAndSetIfChanged(ref operations, value); }
        public int SelectedOperatValue { get => selectedOperatValue; set => this.RaiseAndSetIfChanged(ref selectedOperatValue, value); }

        public string SelectedOperation
        {
            get => _selectedOperation;
            set
            {
                this.RaiseAndSetIfChanged(ref _selectedOperation, value);
                UpdateOperationSymbol();
            }
        }
        public string OperationSymbol { get => _operationSymbol; set => this.RaiseAndSetIfChanged(ref _operationSymbol, value); }

        public void UpdateOperationSymbol()
        {
            switch (SelectedOperation)
            {
                case "": OperationSymbol = "+"; break;
                case "": OperationSymbol = "-"; break;
                case "": OperationSymbol = "*"; break;
                case "": OperationSymbol = "/"; break;
                default: OperationSymbol = string.Empty; break;
            }
        }

        public string Item1 { get => item1; set => this.RaiseAndSetIfChanged(ref item1, value); }
        public string Item2 { get => item2; set => this.RaiseAndSetIfChanged(ref item2, value); }        

        string messege = "";
        public string Messege { get => messege; set => this.RaiseAndSetIfChanged(ref messege, value); }        

        public double sum(double a, double b) {return a + b;}
        public double dif(double a, double b) {return a - b;}
        public double mult(double a, double b) {return a * b;}        

        string resultOperate;
        public string ResultOperate { get => resultOperate; set => this.RaiseAndSetIfChanged(ref resultOperate, value); }        

        public async void calculate()
        {
            double it1, it2;
            Regex isNum = new Regex (@"^[-]?(\d+(,\d*)?|,\d+)$");           

            if (Item1 == null || !isNum.IsMatch(Item1) || Item2 == null || !isNum.IsMatch(Item2))
            {
                it1 = 0; it2 = 0;
                Messege = "  !    / / .";
                ResultOperate = ": !";
                ButtonResult result1 = await MessageBoxManager.GetMessageBoxStandard("  ", Messege,ButtonEnum.Ok).ShowAsync();
            }
            else if (isNum.IsMatch(Item1) && isNum.IsMatch(Item2))
            {
                it1 = Convert.ToDouble(Item1);
                it2 = Convert.ToDouble(Item2);                
                switch (SelectedOperation)
                {
                    case "": ResultOperate = $": {sum(it1, it2).ToString()}"; break;
                    case "": ResultOperate = $": {dif(it1, it2).ToString()}"; break;
                    case "": ResultOperate = $": {mult(it1, it2).ToString()}"; break;
                    case "":
                        if (it2 == 0)
                        {
                            ResultOperate = ": !";
                            Messege = "   !";
                            ButtonResult result2 = await MessageBoxManager.GetMessageBoxStandard("  ", Messege, ButtonEnum.Ok).ShowAsync();
                        }
                        else ResultOperate = $": {Math.Round((it1 / it2),3).ToString()}"; break;
                    default: Messege = "   ."; ButtonResult result = await MessageBoxManager.GetMessageBoxStandard("  ", Messege, ButtonEnum.Ok).ShowAsync(); break;
                }
            }
        }
    }
}